/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.books.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Dictlayerdata.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Dictlayerdata extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Common common;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Dict dict;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**

   * The value returned may be {@code null}.
   */
  public Common getCommon() {
    return common;
  }

  /**

   * The value set may be {@code null}.
   */
  public Dictlayerdata setCommon(Common common) {
    this.common = common;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Dict getDict() {
    return dict;
  }

  /**

   * The value set may be {@code null}.
   */
  public Dictlayerdata setDict(Dict dict) {
    this.dict = dict;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**

   * The value set may be {@code null}.
   */
  public Dictlayerdata setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Model definition for DictlayerdataCommon.
   */
  public static final class Common extends GenericJson {

    /**
     * The display title and localized canonical name to use when searching for this entity on Google
     * search.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String title;

    /**
     * The display title and localized canonical name to use when searching for this entity on Google
     * search.
     * The value returned may be {@code null}.
     */
    public String getTitle() {
      return title;
    }

    /**
     * The display title and localized canonical name to use when searching for this entity on Google
     * search.
     * The value set may be {@code null}.
     */
    public Common setTitle(String title) {
      this.title = title;
      return this;
    }

  }

  /**
   * Model definition for DictlayerdataDict.
   */
  public static final class Dict extends GenericJson {

    /**
     * The source, url and attribution for this dictionary data.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Source source;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<Words> words;

    static {
      // hack to force ProGuard to consider Words used, since otherwise it would be stripped out
      // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
      com.google.api.client.util.Data.nullOf(Words.class);
    }

    /**
     * The source, url and attribution for this dictionary data.
     * The value returned may be {@code null}.
     */
    public Source getSource() {
      return source;
    }

    /**
     * The source, url and attribution for this dictionary data.
     * The value set may be {@code null}.
     */
    public Dict setSource(Source source) {
      this.source = source;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public java.util.List<Words> getWords() {
      return words;
    }

    /**

     * The value set may be {@code null}.
     */
    public Dict setWords(java.util.List<Words> words) {
      this.words = words;
      return this;
    }

    /**
     * The source, url and attribution for this dictionary data.
     */
    public static final class Source extends GenericJson {

      /**
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private String attribution;

      /**
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private String url;

      /**

       * The value returned may be {@code null}.
       */
      public String getAttribution() {
        return attribution;
      }

      /**

       * The value set may be {@code null}.
       */
      public Source setAttribution(String attribution) {
        this.attribution = attribution;
        return this;
      }

      /**

       * The value returned may be {@code null}.
       */
      public String getUrl() {
        return url;
      }

      /**

       * The value set may be {@code null}.
       */
      public Source setUrl(String url) {
        this.url = url;
        return this;
      }

    }
    /**
     * Model definition for DictlayerdataDictWords.
     */
    public static final class Words extends GenericJson {

      /**
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.util.List<Derivatives> derivatives;

      static {
        // hack to force ProGuard to consider Derivatives used, since otherwise it would be stripped out
        // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
        com.google.api.client.util.Data.nullOf(Derivatives.class);
      }

      /**
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.util.List<Examples> examples;

      static {
        // hack to force ProGuard to consider Examples used, since otherwise it would be stripped out
        // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
        com.google.api.client.util.Data.nullOf(Examples.class);
      }

      /**
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.util.List<Senses> senses;

      static {
        // hack to force ProGuard to consider Senses used, since otherwise it would be stripped out
        // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
        com.google.api.client.util.Data.nullOf(Senses.class);
      }

      /**
       * The words with different meanings but not related words, e.g. "go" (game) and "go" (verb).
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private Source source;

      /**

       * The value returned may be {@code null}.
       */
      public java.util.List<Derivatives> getDerivatives() {
        return derivatives;
      }

      /**

       * The value set may be {@code null}.
       */
      public Words setDerivatives(java.util.List<Derivatives> derivatives) {
        this.derivatives = derivatives;
        return this;
      }

      /**

       * The value returned may be {@code null}.
       */
      public java.util.List<Examples> getExamples() {
        return examples;
      }

      /**

       * The value set may be {@code null}.
       */
      public Words setExamples(java.util.List<Examples> examples) {
        this.examples = examples;
        return this;
      }

      /**

       * The value returned may be {@code null}.
       */
      public java.util.List<Senses> getSenses() {
        return senses;
      }

      /**

       * The value set may be {@code null}.
       */
      public Words setSenses(java.util.List<Senses> senses) {
        this.senses = senses;
        return this;
      }

      /**
       * The words with different meanings but not related words, e.g. "go" (game) and "go" (verb).
       * The value returned may be {@code null}.
       */
      public Source getSource() {
        return source;
      }

      /**
       * The words with different meanings but not related words, e.g. "go" (game) and "go" (verb).
       * The value set may be {@code null}.
       */
      public Words setSource(Source source) {
        this.source = source;
        return this;
      }

      /**
       * Model definition for DictlayerdataDictWordsDerivatives.
       */
      public static final class Derivatives extends GenericJson {

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private Source source;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private String text;

        /**

         * The value returned may be {@code null}.
         */
        public Source getSource() {
          return source;
        }

        /**

         * The value set may be {@code null}.
         */
        public Derivatives setSource(Source source) {
          this.source = source;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public String getText() {
          return text;
        }

        /**

         * The value set may be {@code null}.
         */
        public Derivatives setText(String text) {
          this.text = text;
          return this;
        }

        /**
         * Model definition for DictlayerdataDictWordsDerivativesSource.
         */
        public static final class Source extends GenericJson {

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String attribution;

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String url;

          /**

           * The value returned may be {@code null}.
           */
          public String getAttribution() {
            return attribution;
          }

          /**

           * The value set may be {@code null}.
           */
          public Source setAttribution(String attribution) {
            this.attribution = attribution;
            return this;
          }

          /**

           * The value returned may be {@code null}.
           */
          public String getUrl() {
            return url;
          }

          /**

           * The value set may be {@code null}.
           */
          public Source setUrl(String url) {
            this.url = url;
            return this;
          }

        }
      }
      /**
       * Model definition for DictlayerdataDictWordsExamples.
       */
      public static final class Examples extends GenericJson {

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private Source source;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private String text;

        /**

         * The value returned may be {@code null}.
         */
        public Source getSource() {
          return source;
        }

        /**

         * The value set may be {@code null}.
         */
        public Examples setSource(Source source) {
          this.source = source;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public String getText() {
          return text;
        }

        /**

         * The value set may be {@code null}.
         */
        public Examples setText(String text) {
          this.text = text;
          return this;
        }

        /**
         * Model definition for DictlayerdataDictWordsExamplesSource.
         */
        public static final class Source extends GenericJson {

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String attribution;

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String url;

          /**

           * The value returned may be {@code null}.
           */
          public String getAttribution() {
            return attribution;
          }

          /**

           * The value set may be {@code null}.
           */
          public Source setAttribution(String attribution) {
            this.attribution = attribution;
            return this;
          }

          /**

           * The value returned may be {@code null}.
           */
          public String getUrl() {
            return url;
          }

          /**

           * The value set may be {@code null}.
           */
          public Source setUrl(String url) {
            this.url = url;
            return this;
          }

        }
      }
      /**
       * Model definition for DictlayerdataDictWordsSenses.
       */
      public static final class Senses extends GenericJson {

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private java.util.List<Conjugations> conjugations;

        static {
          // hack to force ProGuard to consider Conjugations used, since otherwise it would be stripped out
          // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
          com.google.api.client.util.Data.nullOf(Conjugations.class);
        }

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private java.util.List<Definitions> definitions;

        static {
          // hack to force ProGuard to consider Definitions used, since otherwise it would be stripped out
          // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
          com.google.api.client.util.Data.nullOf(Definitions.class);
        }

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private String partOfSpeech;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private String pronunciation;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private String pronunciationUrl;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private Source source;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private String syllabification;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private java.util.List<Synonyms> synonyms;

        static {
          // hack to force ProGuard to consider Synonyms used, since otherwise it would be stripped out
          // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
          com.google.api.client.util.Data.nullOf(Synonyms.class);
        }

        /**

         * The value returned may be {@code null}.
         */
        public java.util.List<Conjugations> getConjugations() {
          return conjugations;
        }

        /**

         * The value set may be {@code null}.
         */
        public Senses setConjugations(java.util.List<Conjugations> conjugations) {
          this.conjugations = conjugations;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public java.util.List<Definitions> getDefinitions() {
          return definitions;
        }

        /**

         * The value set may be {@code null}.
         */
        public Senses setDefinitions(java.util.List<Definitions> definitions) {
          this.definitions = definitions;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public String getPartOfSpeech() {
          return partOfSpeech;
        }

        /**

         * The value set may be {@code null}.
         */
        public Senses setPartOfSpeech(String partOfSpeech) {
          this.partOfSpeech = partOfSpeech;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public String getPronunciation() {
          return pronunciation;
        }

        /**

         * The value set may be {@code null}.
         */
        public Senses setPronunciation(String pronunciation) {
          this.pronunciation = pronunciation;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public String getPronunciationUrl() {
          return pronunciationUrl;
        }

        /**

         * The value set may be {@code null}.
         */
        public Senses setPronunciationUrl(String pronunciationUrl) {
          this.pronunciationUrl = pronunciationUrl;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public Source getSource() {
          return source;
        }

        /**

         * The value set may be {@code null}.
         */
        public Senses setSource(Source source) {
          this.source = source;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public String getSyllabification() {
          return syllabification;
        }

        /**

         * The value set may be {@code null}.
         */
        public Senses setSyllabification(String syllabification) {
          this.syllabification = syllabification;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public java.util.List<Synonyms> getSynonyms() {
          return synonyms;
        }

        /**

         * The value set may be {@code null}.
         */
        public Senses setSynonyms(java.util.List<Synonyms> synonyms) {
          this.synonyms = synonyms;
          return this;
        }

        /**
         * Model definition for DictlayerdataDictWordsSensesConjugations.
         */
        public static final class Conjugations extends GenericJson {

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String type;

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String value;

          /**

           * The value returned may be {@code null}.
           */
          public String getType() {
            return type;
          }

          /**

           * The value set may be {@code null}.
           */
          public Conjugations setType(String type) {
            this.type = type;
            return this;
          }

          /**

           * The value returned may be {@code null}.
           */
          public String getValue() {
            return value;
          }

          /**

           * The value set may be {@code null}.
           */
          public Conjugations setValue(String value) {
            this.value = value;
            return this;
          }

        }
        /**
         * Model definition for DictlayerdataDictWordsSensesDefinitions.
         */
        public static final class Definitions extends GenericJson {

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String definition;

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private java.util.List<Examples> examples;

          static {
            // hack to force ProGuard to consider Examples used, since otherwise it would be stripped out
            // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
            com.google.api.client.util.Data.nullOf(Examples.class);
          }

          /**

           * The value returned may be {@code null}.
           */
          public String getDefinition() {
            return definition;
          }

          /**

           * The value set may be {@code null}.
           */
          public Definitions setDefinition(String definition) {
            this.definition = definition;
            return this;
          }

          /**

           * The value returned may be {@code null}.
           */
          public java.util.List<Examples> getExamples() {
            return examples;
          }

          /**

           * The value set may be {@code null}.
           */
          public Definitions setExamples(java.util.List<Examples> examples) {
            this.examples = examples;
            return this;
          }

          /**
           * Model definition for DictlayerdataDictWordsSensesDefinitionsExamples.
           */
          public static final class Examples extends GenericJson {

            /**
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private Source source;

            /**
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private String text;

            /**

             * The value returned may be {@code null}.
             */
            public Source getSource() {
              return source;
            }

            /**

             * The value set may be {@code null}.
             */
            public Examples setSource(Source source) {
              this.source = source;
              return this;
            }

            /**

             * The value returned may be {@code null}.
             */
            public String getText() {
              return text;
            }

            /**

             * The value set may be {@code null}.
             */
            public Examples setText(String text) {
              this.text = text;
              return this;
            }

            /**
             * Model definition for DictlayerdataDictWordsSensesDefinitionsExamplesSource.
             */
            public static final class Source extends GenericJson {

              /**
               * The value may be {@code null}.
               */
              @com.google.api.client.util.Key
              private String attribution;

              /**
               * The value may be {@code null}.
               */
              @com.google.api.client.util.Key
              private String url;

              /**

               * The value returned may be {@code null}.
               */
              public String getAttribution() {
                return attribution;
              }

              /**

               * The value set may be {@code null}.
               */
              public Source setAttribution(String attribution) {
                this.attribution = attribution;
                return this;
              }

              /**

               * The value returned may be {@code null}.
               */
              public String getUrl() {
                return url;
              }

              /**

               * The value set may be {@code null}.
               */
              public Source setUrl(String url) {
                this.url = url;
                return this;
              }

            }
          }
        }
        /**
         * Model definition for DictlayerdataDictWordsSensesSource.
         */
        public static final class Source extends GenericJson {

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String attribution;

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String url;

          /**

           * The value returned may be {@code null}.
           */
          public String getAttribution() {
            return attribution;
          }

          /**

           * The value set may be {@code null}.
           */
          public Source setAttribution(String attribution) {
            this.attribution = attribution;
            return this;
          }

          /**

           * The value returned may be {@code null}.
           */
          public String getUrl() {
            return url;
          }

          /**

           * The value set may be {@code null}.
           */
          public Source setUrl(String url) {
            this.url = url;
            return this;
          }

        }
        /**
         * Model definition for DictlayerdataDictWordsSensesSynonyms.
         */
        public static final class Synonyms extends GenericJson {

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private Source source;

          /**
           * The value may be {@code null}.
           */
          @com.google.api.client.util.Key
          private String text;

          /**

           * The value returned may be {@code null}.
           */
          public Source getSource() {
            return source;
          }

          /**

           * The value set may be {@code null}.
           */
          public Synonyms setSource(Source source) {
            this.source = source;
            return this;
          }

          /**

           * The value returned may be {@code null}.
           */
          public String getText() {
            return text;
          }

          /**

           * The value set may be {@code null}.
           */
          public Synonyms setText(String text) {
            this.text = text;
            return this;
          }

          /**
           * Model definition for DictlayerdataDictWordsSensesSynonymsSource.
           */
          public static final class Source extends GenericJson {

            /**
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private String attribution;

            /**
             * The value may be {@code null}.
             */
            @com.google.api.client.util.Key
            private String url;

            /**

             * The value returned may be {@code null}.
             */
            public String getAttribution() {
              return attribution;
            }

            /**

             * The value set may be {@code null}.
             */
            public Source setAttribution(String attribution) {
              this.attribution = attribution;
              return this;
            }

            /**

             * The value returned may be {@code null}.
             */
            public String getUrl() {
              return url;
            }

            /**

             * The value set may be {@code null}.
             */
            public Source setUrl(String url) {
              this.url = url;
              return this;
            }

          }
        }
      }
      /**
       * The words with different meanings but not related words, e.g. "go" (game) and "go" (verb).
       */
      public static final class Source extends GenericJson {

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private String attribution;

        /**
         * The value may be {@code null}.
         */
        @com.google.api.client.util.Key
        private String url;

        /**

         * The value returned may be {@code null}.
         */
        public String getAttribution() {
          return attribution;
        }

        /**

         * The value set may be {@code null}.
         */
        public Source setAttribution(String attribution) {
          this.attribution = attribution;
          return this;
        }

        /**

         * The value returned may be {@code null}.
         */
        public String getUrl() {
          return url;
        }

        /**

         * The value set may be {@code null}.
         */
        public Source setUrl(String url) {
          this.url = url;
          return this;
        }

      }
    }
  }

}
