/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.books.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for RequestAccess.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class RequestAccess extends GenericJson {

  /**
   * A concurrent access response.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ConcurrentAccessRestriction concurrentAccess;

  /**
   * A download access response.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private DownloadAccessRestriction downloadAccess;

  /**
   * Resource type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * A concurrent access response.
   * The value returned may be {@code null}.
   */
  public ConcurrentAccessRestriction getConcurrentAccess() {
    return concurrentAccess;
  }

  /**
   * A concurrent access response.
   * The value set may be {@code null}.
   */
  public RequestAccess setConcurrentAccess(ConcurrentAccessRestriction concurrentAccess) {
    this.concurrentAccess = concurrentAccess;
    return this;
  }

  /**
   * A download access response.
   * The value returned may be {@code null}.
   */
  public DownloadAccessRestriction getDownloadAccess() {
    return downloadAccess;
  }

  /**
   * A download access response.
   * The value set may be {@code null}.
   */
  public RequestAccess setDownloadAccess(DownloadAccessRestriction downloadAccess) {
    this.downloadAccess = downloadAccess;
    return this;
  }

  /**
   * Resource type.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Resource type.
   * The value set may be {@code null}.
   */
  public RequestAccess setKind(String kind) {
    this.kind = kind;
    return this;
  }

}
